
/********************************************************************
*
* fxm.h-- data sizes for FAX
*
*
*********************************************************************/
#ifdef SC_IMAGE
#define SCAN_P_SIZE 5000
     /* ...logical size of collision list space                     */
#define HASH_T_SIZE 800
     /* ...logical size of hash table in bytes                      */
#define BSCAN_SIZE 5000
#define BHASH_SIZE 800
#endif

#ifdef NO_IMAGE
#define SCAN_P_SIZE 1250
#define HASH_T_SIZE 200
#define BSCAN_SIZE 5000
#define BHASH_SIZE 800
#endif

#define CHUNK_SIZE 33000
     /* ...32K == screen size in bytes                              */
#define DUMP_SIZE 2000
     /* ...total string space for dump                              */
#define SCRN_SIZE 33000
     /* ... i.e., roughly 32k --for a full screen buffer            */
#define SMALL_SCRN 9000 
     /* ... just enough for size of window we're using              */



