* ARC Shell II
*
* by Charles F. Johnson
*
* Last revision: 03/01/87  13:52:40

harddisk	=	0	Conditional assembly flag

* Object type equates

G_BOX		=	20
G_TEXT		=	21
G_BOXTEXT	=	22
G_IMAGE		=	23
G_PROGDEF	=	24
G_IBOX		=	25
G_BUTTON	=	26
G_BOXCHAR	=	27
G_STRING	=	28
G_FTEXT		=	29
G_FBOXTEXT	=	30
G_ICON		=	31
G_TITLE		=	32

* Object flag equates

NONE		=	$00
SELECTABLE	=	$01
DEFAULT		=	$02
EXIT		=	$04
EDITABLE	=	$08
RBUTTON		=	$10
LASTOB		=	$20
TOUCHEXIT	=	$40
HIDETREE	=	$80
INDIRECT	=	$0100

* Object status	equates

NORMAL		=	$00
SELECTED	=	$01
CROSSED		=	$02
CHECKED		=	$04
DISABLED	=	$08
OUTLINED	=	$10
SHADOWED	=	$20

* Object index equates

addbt	=	3
movbt	=	5
updbt	=	7
frshbt	=	9
delbt	=	11
extbt	=	4
runbt	=	6
copybt	=	8
listbt	=	10
verbbt	=	12
testbt	=	13
convbt	=	14
retnbt	=	16
supcbt	=	17
supmbt	=	18
supnbt	=	19
holdbt	=	20
crypbt	=	21
arcbt	=	25
exitbt	=	26
adriv	=	22
ddriv	=	23

lscrn	=	3
lprnt	=	4
ldisk	=	5
okbt	=	6
cncbt	=	7

	text

	move.l	a7,a5		GEMDOS mshrink command to release
	move.l	#nstack,a7	memory unneeded by this program
	move.l	4(a5),a5
	move.l	$c(a5),d0
	add.l	$14(a5),d0
	add.l	$1c(a5),d0
	add.l	#$100,d0
	move.l	d0,-(sp)
	move.l	a5,-(sp)
	clr.w	-(sp)
	move	#$4a,-(sp)
	trap	#1
	add.l	#12,sp

	move.w	#4,-(sp)	Get current resolution
	trap	#14
	addq.l	#2,sp
	move.w	d0,res		Save it

	tst.w	d0		Low res?
	bne	cont1		No, continue
	move.l	#nolow,a5	Show alert box
	move	#1,d5		and get outta here
	bsr	alert
	bra	ex2

cont1:	move.w	#$19,-(sp)	Get current drive
	trap	#1
	addq.l	#2,sp
	add.b	#65,d0		Make it ASCII
	move.b	d0,arcnam	Set the first character of every fsel
	move.b	d0,arcdir	directory line to the current drive
	move.b	d0,datdir

	.ifeq	harddisk
	move.b	d0,whrdir
	.endc

	move.b	d0,devdir
	move.b	d0,atext
	move.b	d0,dtext
	move.b	#':',arcnam+1	Now move in the necessary colon
	move.b	#':',arcdir+1
	move.b	#':',datdir+1

	.ifeq	harddisk
	move.b	#':',whrdir+1
	.endc

	move.b	#':',devdir+1

	clr	-(sp)		Get current pathname
	move.l	#curpth,-(sp)
	move	#$47,-(sp)
	trap	#1
	addq.l	#8,sp

	move.l	#curpth,a0	Set all these directory lines to the
	move.l	#devdir+2,a3	current path and then add the search
	move.l	#arcdir+2,a4	spec (either "\*.ARC" or "\*.*")
	move.l	#datdir+2,a5
	move	#63,d5
cdir1:	tst.b	(a0)
	beq	cdir2
	move.b	(a0),(a3)+
	move.b	(a0),(a4)+
	move.b	(a0)+,(a5)+
	dbf	d5,cdir1
cdir2:	move.l	#adnam,a0
	move	#6,d5
cdir3:	move.b	(a0)+,(a4)+
	dbf	d5,cdir3
	move.l	#ddnam,a0
	move	#4,d5
cdir4:	move.b	(a0),(a3)+
	move.b	(a0)+,(a5)+
	dbf	d5,cdir4

	move.l	#r_obfx,aespb	Rsrc_obfix is the AES call to convert the
	move.w	#30,d5		coordinates of an object from character
	move.l	#arcbox,addrin	positions to pixel positions based on the
fxarc:	move.w	d5,intin	current res. It has to be called for every
	bsr	aes		object in the tree.
	dbf	d5,fxarc
	move.w	#7,d5
	move.l	#lstbox,addrin
fxdev:	move.w	d5,intin
	bsr	aes
	dbf	d5,fxdev

	clr.b	etext		Set TEDINFO string to null

	cmp.w	#2,res		Let's move the author's name (ahem) in the
	bne	nothi1		title box down a bit to give it a
	addq.w	#4,authry	subscript look
	bra	next
nothi1:	addq.w	#1,authry

next:	move.l	#$A000,a5	This section searches for the fsel_input
s_1:	move.l	#itmtxt,a4	text "ITEM SELECTOR", then searches
	move.l	#12,d5		backwards for the pointer to this text
s_2:	move.b	(a5),d0		in the fsel object tree. New string
	cmp.b	(a4),d0		addresses can be poked into this location.
	beq	s_3
	addq.l	#1,a5
	bra	s_2
s_3:	move.l	a5,a0
s_4:	cmp.b	(a5)+,(a4)+
	bne	s_1
	dbf	d5,s_4
	move.l	a0,d0
	move.l	a0,iasav
	move.l	a0,d1
	and.l	#$FFFFFFFE,d1
	move.l	d1,a0
s_5:	subq.l	#2,a0
	move.l	(a0),d1
	cmp.l	d1,d0
	bne	s_5
	move.l	a0,itmadr

	move.w	8(a0),ilensv	Save original string length

	bsr	finger		Set the pointing finger

	.ifeq	harddisk

	bsr	getdat		Is ARC.TTP somewhere close by?
	bpl	gotarc		Yes! Skip ahead

	move.l	#ddnam,a4	Set directory line for "Where is ARC?"
	move.l	#whrdir+2,a5	file selector
	move.w	#4,d5
setf1:	move.b	(a4)+,(a5)+
	dbf	d5,setf1

	move.l	#i_wher,a4	Text address
	move.w	#iw_len*8,d5	Text length
	move.l	#whrdir,diradr	Set address of directory line
	move.l	#whrfil,filadr	Address of filename line
	bsr	fsel		Go call fsel_input

	cmp.w	#1,intout+2	Did we exit with OK?
	bne	ex2		No, so let's bail
	tst.b	whrfil		Is there a filename present?
	beq	ex2		No, bail here as well

	move.l	#arcnam,a5	Address of ARC filename
	move.l	#whrdir,a4	Fsel directory line
	bsr	dopath		Go set up the pathname

	move.l	#whrfil,a4	Now move in the selected filename
	move.w	#11,d5
whr5:	move.b	(a4),(a5)+
	tst.b	(a4)+
	beq	drawit
	dbf	d5,whr5
	bra	drawit		Go draw the main dialog box

gotarc:	move.l	#arcnam+2,a5	We end up here if ARC.TTP is present
	move.l	#curpth,a4	Copy current pathname to ARC filename area
	move.w	#63,d5
cpypth:	tst.b	(a4)
	beq	cpth2
	move.b	(a4)+,(a5)+
	dbf	d5,cpypth
cpth2:	move.b	#'\',(a5)+
	move.l	#arcn1,a4	Now move in the filename
	move	#7,d5
cpth3:	move.b	(a4)+,(a5)+
	dbf	d5,cpth3

	.endc

drawit:	bsr	mouscl		Hide mouse and clear screen

	move.l	#arcbox,boxadr	Draw the dialog and get input
	bsr	drawbx
	clr.w	state
	bsr	change		Reset selected button

	cmp.w	#exitbt,selobj	Exit?
	beq	ex2		I guess so. Let's ramble on.

	bsr	mouscl		Hide mouse and clear screen

	move.l	#cmdlin+1,a5	Set pointer to start of command string
	btst	#0,addstt+1	This next long and somewhat repetitious
	beq	c1		section of code checks the object status
	move.b	#'a',(a5)+	flags for each object in the dialog, and
	bra	ck2		moves the appropriate ASCII character to
c1:	btst	#0,movstt+1	the command line if an object is selected.
	beq	c2		(That was "ADD" above.)
	move.b	#'m',(a5)+	"MOVE"
	bra	ck2
c2:	btst	#0,updstt+1
	beq	c3
	move.b	#'u',(a5)+	"UPDATE"
	bra	ck2
c3:	btst	#0,frestt+1
	beq	c4
	move.b	#'f',(a5)+	"FRESHEN"
	bra	ck2
c4:	btst	#0,delstt+1
	beq	c5
	move.b	#'d',(a5)+	"DELETE"
	bra	ck2
c5:	btst	#0,extstt+1
	beq	c6
	move.b	#'x',(a5)+	"EXTRACT"
	bra	ck2
c6:	btst	#0,runstt+1
	beq	c7
	move.b	#'r',(a5)+	"RUN"
	bra	ck2
c7:	btst	#0,copstt+1
	beq	c8
	move.b	#'p',(a5)+	"COPY"
	bra	ck2
c8:	btst	#0,lststt+1
	beq	c9
	move.b	#'l',(a5)+	"LIST"
	bra	ck2
c9:	btst	#0,verstt+1
	beq	c10
	move.b	#'v',(a5)+	"VERBOSE LIST"
	bra	ck2
c10:	btst	#0,tesstt+1
	beq	c11
	move.b	#'t',(a5)+	"TEST"
	bra	ck2
c11:	btst	#0,cnvstt+1
	beq	drawit
	move.b	#'c',(a5)+	"CONVERT"

ck2:	btst	#0,retstt+1	Whew! That's it for the radio buttons. Now
	beq	c12		let's check the secondary options
	move.b	#'b',(a5)+	"RETAIN BACKUP"
c12:	btst	#0,sucstt+1
	beq	c13
	move.b	#'s',(a5)+	"SUPPRESS COMPRESSION"
c13:	btst	#0,sumstt+1
	beq	c14
	move.b	#'w',(a5)+	"SUPPRESS WARNINGS"
c14:	btst	#0,sunstt+1
	beq	c15
	move.b	#'n',(a5)+	"SUPPRESS NOTES"
c15:	btst	#0,holstt+1
	beq	ck3
	move.b	#'h',(a5)+	"HOLD SCREEN"

ck3:	btst	#0,crystt+1	"ENCRYPT/DECRYPT"
	beq	ck4
	tst.b	etext		Is there a keyword string?
	beq	ck4		No, skip ahead
	move.b	#'g',(a5)+	Move in the ASCII command
	move.l	#etext,a4	Now move in the encryption keyword
	move.w	#3,d5		from the TEDINFO string
cpyc1:	tst.b	(a4)
	beq	cpyc2
	move.b	(a4)+,(a5)+
	dbf	d5,cpyc1
cpyc2:
ck4:	move.b	#' ',(a5)+	Space delimiter

	move.b	atext,d0	Get ARC drive character
	and.w	#$DF,d0		Mask off lowercase
	cmp.b	arcdir,d0	Same as directory line?
	beq	doafsl		Yes, skip ahead
	move.l	#arcdir,a0	Re-form the directory line for
	move.b	d0,(a0)+	ARC files
	move.b	#':',(a0)+
	move.l	#adnam,a1
	move	#6,d5
setaf1:	move.b	(a1)+,(a0)+
	dbf	d5,setaf1

doafsl:	move.l	#i_arcn,a4	Set addresses for calling fsel_input
	move.w	#ia_len*8,d5
	move.l	#arcdir,diradr
	move.l	#afile,filadr
	bsr	fsel		Call de puppy

	cmp.w	#1,intout+2	Click on OK?
	bne	drawit		No, back to the top
	tst.b	afile		Filename present?
	beq	drawit		No, to the top!

	move.l	#arcdir,a4	Address of directory line
	bsr	dopath		Go form the pathname

	move.l	#afile,a4	Now move in the selected filename
	move.w	#11,d5		from the fsel area
anam5:	tst.b	(a4)
	beq	anam6
	move.b	(a4)+,(a5)+
	dbf	d5,anam5

anam6:	btst	#0,lststt+1	If LIST or VERBOSE LIST, go show the
	bne	dev1		"Which device" dialog box
	btst	#0,verstt+1
	bne	dev1
	btst	#0,tesstt+1	If TEST, skip over
	bne	dnam8
	bra	dnam0

dev1:	bsr	mouscl
	move.l	#lstbox,boxadr	Draw the "Which device" box
	bsr	drawbx
	clr.w	state
	bsr	change		As always, reset the selected object
	cmp.w	#okbt,selobj	Was it OK for you?
	bne	drawit		No, try again

	btst	#0,scrstt+1	Screen is default, so skip ahead
	bne	dnam8
	move.b	#' ',(a5)+	Space
	move.b	#'>',(a5)+	Greater than sign denotes I/O redirection
	btst	#0,prtstt+1	Is it the printer?
	beq	devf1		No, go get a filename
	move.b	#'P',(a5)+	Move in the file spec for printer
	move.b	#'R',(a5)+
	move.b	#'T',(a5)+
	move.b	#':',(a5)+
	bra	dnam8

devf1:	move.l	#i_lfil,a4	Set addresses
	move.w	#il_len*8,d5
	move.l	#devdir,diradr
	move.l	#lfile,filadr
	bsr	fsel		fsel_input
	cmp.w	#1,intout+2	OK?
	bne	drawit		No, back to the top
	tst.b	lfile		Filename?
	beq	drawit		No!

	move.l	#devdir,a4	Go build the pathname
	bsr	dopath

	move.l	#lfile,a4	Move in the filename to which the list
	move.w	#11,d5		will occur
lnam5:	tst.b	(a4)
	beq	lnam6
	move.b	(a4)+,(a5)+
	dbf	d5,lnam5
lnam6:	bra	dnam8

dnam0:	move.b	#' ',(a5)+	Once again, a space delimiter
	clr.w	dfflag		Flag for *.* wildcard in case of empty name

	move.b	dtext,d0	Get data drive
	and.w	#$DF,d0		Strip lowercase
	cmp.b	datdir,d0	Same as directory line?
	beq	dodfsl		Yes, skip ahead
	move.l	#datdir,a0	Re-init the data directory line for
	move.b	d0,(a0)+	fsel_input
	move.b	#':',(a0)+
	move.l	#ddnam,a1
	move	#4,d5
setdf1:	move.b	(a1)+,(a0)+
	dbf	d5,setdf1

dodfsl:	move.l	#i_datn,a4	Set addresses
	move.w	#id_len*8,d5
	move.l	#datdir,diradr
	move.l	#dfile,filadr
	bsr	fsel		fsel_input

	cmp.w	#1,intout+2	OK?
	bne	drawit		No, back to the top with you
	tst.b	dfile		Is there a filename here?
	bne	dnam1		Yes, skip one instruction
	move.w	#1,dfflag	Set the wildcard flag
dnam1:	btst	#0,runstt+1	Is this a "RUN" command?
	bne	dodf1		Yes, skip ahead
	move.l	#datdir,a4	Move in the pathname from fsel
	move.w	#63,d5
dnam2:	tst.b	(a4)
	beq	dnam3
	move.b	(a4)+,(a5)+
	dbf	d5,dnam2
dnam3:	tst.w	dfflag		Wildcard?
	bne	dnam8		Yes, skip ahead

	bsr	dopth2		Form rest of pathname

dodf1:	move.l	#dfile,a4	Move in the filename
	move.w	#11,d5
dnam7:	tst.b	(a4)
	beq	dnam8
	move.b	(a4)+,(a5)+
	dbf	d5,dnam7

dnam8:	clr.b	(a5)		Set zero at end of command line
	move.l	#cmdlin+1,a5	Start of command line
	clr.l	d5		Clear counter
fndend:	tst.b	(a5)+		Search for the zero
	beq	founde		Got it! We're at the end
	addq.b	#1,d5		Count 'em up
	bra	fndend		Keep countin'
founde:	move.b	d5,cmdlin	Move in the length

	btst	#0,runstt+1	"RUN"?
	bne	doexe1		Yes, skip the mouse hide
	dc.w	$A00A
doexe1:	bsr	clears		Clear screen

	pea	cmdlin+1	Print the command line to the screen
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp	
	pea	retmsg
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	pea	retmsg
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp

	clr.w	prtflg		Clear printer flag
	btst	#0,lststt+1	Is it LIST?
	bne	cklst1		Yes, go check it
	btst	#0,verstt+1	VERBOSE LIST?
	beq	exec		No, skip ahead
cklst1:	btst	#0,dskstt+1	Is it to DISK?
	bne	exec		Yes, skip ahead
	move.l	#afile,a0	Copy the ARC file name to the filename
	move.l	#fn2,a1		message area, then print it to the
	move.w	#12,d5		proper device (screen or printer)
cklst2:	move.b	(a0),(a1)+
	tst.b	(a0)+
	beq	cklst3
	dbf	d5,cklst2
cklst3:	btst	#0,scrstt+1
	beq	cklst4
	move.w	#2,d4
	bra	cklst5
cklst4:	move.w	#0,d4
	move.w	#1,prtflg
cklst5:	move.l	#fnmsg,a5
	bsr	conout
cklst7:	move.w	#1,d6
cklst8:	move.l	#retmsg,a5
	bsr	conout
	dbf	d6,cklst8

exec:	pea	env		Here's where we actually call ARC.TTP
	pea	cmdlin		Pointer to command line

	.ifeq	harddisk
	pea	arcnam		Filename
	.endc

	.ifne	harddisk
	pea	arcn1
	.endc

	clr.w	-(sp)
	move.w	#$4B,-(sp)	GEMDOS Pexec function
	trap	#1
	add.l	#16,sp

	btst	#0,runstt+1	Was it "RUN"?
	bne	drawit		Yes, back to the top
	tst.w	prtflg		Was it a list to the printer?
	beq	after1		No, skip
	move.l	#retmsg,a5	Print a line-feed
	bsr	conout
after1:	bsr	showms		Show that cute li'l mousey
	bra	drawit		Draw the box and start the whole thing again

ex2:	clr.w	-(sp)		Back to the desktop
	trap	#1

getdat:	pea	dta		Set address of GEMDOS DTA area
	move	#$1A,-(sp)
	trap	#1
	addq.l	#6,sp

	clr	-(sp)		SFIRST - search for first name in
	move.l	#arcn1,-(sp)	directory that matches the filespec
	move	#$4E,-(sp)
	trap	#1
	addq.l	#8,sp
	tst	d0
	rts

* Print string with BIOS bconout function
* Enter with: a5= Address of null-terminated string
*	      d4= Output device number

conout:	clr.l	d5
con1:	tst.b	(a5)
	beq	conex
	move.b	(a5)+,d5
	move.w	d5,-(sp)
	move.w	d4,-(sp)
	move.w	#3,-(sp)
	trap	#13
	addq.l	#6,sp
	bra	con1
conex:	rts

mouscl:	dc.w	$A00A
	bsr	clears
showms:	dc.w	$A009		Show mouse
	rts

clears:	pea	clrhom		Clear the screen with VT52 sequence
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	rts

dopath:	move.w	#63,d5		Build a pathname from the output of a
dopth1:	tst.b	(a4)		fsel_input call
	beq	dopth2		First, search for the zero at the end
	move.b	(a4)+,(a5)+
	dbf	d5,dopth1
dopth2:	move.w	#11,d5		Now search backwards for the backslash
dopth3:	move.b	-(a5),d0
	cmp.b	#'\',d0
	beq	dopth4
	dbf	d5,dopth3
dopth4:	addq.l	#1,a5		a5 now points at the 1st char past "\"
	rts

* form_alert
* Enter with a5= address of definition string
*	     d5= number of default box

alert:	move.l	a5,addrin	Set address of string
	move.w	d5,intin	Set default box
	move.l	#f_alrt,aespb	Display alert box
	bra	aes

finger:	move.l	#g_mous,aespb	Set pointing finger
	move.w	#3,intin
	bra	aes

fsel:	move.l	itmadr,a0	Replace "ITEM SELECTOR" text with string
	move.l	a4,(a0)		Enter with a4= address of string
	move.w	d5,8(a0)		   d5= length of string
	or.w	#SELECTED,-2(a0)  Set fsel title to SELECTED (inverse)

	bsr	mouscl		Clear screen

	move.l	#f_sel,aespb	Summon up the dreaded file selector
	move.l	diradr,addrin
	move.l	filadr,addrin+4
	bsr	aes

	bsr	mouscl

	move.l	itmadr,a4	Restore pointer to fsel_input text
	move.l	iasav,(a4)
	and.w	#$FE,-2(a4)
	move.w	ilensv,8(a4)
	bra	finger		Reset pointing finger and return

* Dialog box drawing routine
* Enter with boxadr= object tree address

drawbx:	move.l	#f_cntr,aespb	First, let's call form_center
	move.l	boxadr,addrin
	bsr	aes
	move.w	intout+2,cx
	move.w	intout+4,cy
	move.l	boxadr,a0	Let's move the box up a bit from its
	sub.w	#4,cy		supposedly centered coordinates...without
	sub.w	#4,18(a0)	a menu bar it looks too low on the screen.
	cmp.w	#2,res
	bne	db2
	sub.w	#4,cy
	sub.w	#4,18(a0)
db2:	move.w	intout+6,cw
	addq.w	#4,cw
	move.w	intout+8,ch
	addq.w	#4,ch

	clr.w	diflag		Reserve screen buffer memory
	bsr	dial
	move.l	#o_cdrw,aespb	Now, let's call objc_draw
	clr.w	intin		Root object gets drawn first
	move.w	#6,intin+2	Up to 1 level of subordinate objects
	move.w	cx,intin+4
	move.w	cy,intin+6
	move.w	cw,intin+8
	move.w	ch,intin+10
	move.l	boxadr,addrin
	bsr	aes

formdo:	move.l	#f_do,aespb	Here's where it all happens --- form_do
	clr.w	intin		No editable text field
	move.l	boxadr,addrin
	bsr	aes
	move.w	intout,selobj
	rts

* form_dial

dial:	move.l	#f_dial,aespb
	move.w	diflag,intin	diflag determines which action is taken

	move.w	#16,intin+2	Expanding box will grow from "Desk"
	move.w	#2,intin+4	on menu bar
	move.w	#64,intin+6
	cmp.w	#2,res		Adjust for different resolutions
	beq	cntrs1
	move.w	#8,intin+8
	bra	cntrs2
cntrs1:	move.w	#16,intin+8
cntrs2:	move.w	cx,intin+10
	move.w	cy,intin+12
	move.w	cw,intin+14
	move.w	ch,intin+16
	bra	aes

* objc_change

change:	move.l	#o_chng,aespb	Resets a selected object after exiting dialog
	move.w	selobj,intin
	clr.w	intin+2
	move.w	cx,intin+4
	move.w	cy,intin+6
	move.w	cw,intin+8
	move.w	ch,intin+10
	move.w	state,intin+12
	clr.w	intin+14
	move.l	boxadr,addrin
	bra	aes

* AES subroutine

aes:	move.l	#aespb,d1
	move.l	#$c8,d0
	trap	#2
	rts

	data
	even

* TEDINFO structures

tinf0:	dc.l	atext,atemp,avalid
	dc.w	3,6,2,$1180,0,-1,2,13
tinf1:	dc.l	dtext,dtemp,dvalid
	dc.w	3,6,2,$1180,0,-1,2,14
tinf2:	dc.l	etext,etemp,evalid
	dc.w	3,6,2,$1180,0,-1,5,25
tinf3:	dc.l	author,null,null
	dc.w	5,6,0,$1180,0,-1,22,1
tinf4:	dc.l	copyrt,null,null
	dc.w	5,6,2,$1180,0,-1,47,1

* OBJECT TREES

* The main object tree

arcbox:	dc.w	-1,1,27,G_BOX,NONE,SHADOWED
	dc.l	$21132
	dc.w	0
arcbxy:	dc.w	0,70,22

	dc.w	25,2,24,G_BOX,NONE,SHADOWED
	dc.l	$FF1143
	dc.w	2,1,66,17

	dc.w	15,3,14,G_BOX,NONE,NORMAL
	dc.l	$1143
	dc.w	1,0,35,14

	dc.w	4,-1,-1,G_BUTTON,$11
addstt:	dc.w	NORMAL
	dc.l	addms
	dc.w	1,1,16,1

	dc.w	5,-1,-1,G_BUTTON,$11
extstt:	dc.w	SELECTED
	dc.l	extms
	dc.w	19,1,16,1

	dc.w	6,-1,-1,G_BUTTON,$11
movstt:	dc.w	NORMAL
	dc.l	movms
	dc.w	1,3,16,1

	dc.w	7,-1,-1,G_BUTTON,$11
runstt:	dc.w	NORMAL
	dc.l	runms
	dc.w	19,3,16,1

	dc.w	8,-1,-1,G_BUTTON,$11
updstt:	dc.w	NORMAL
	dc.l	updms
	dc.w	1,5,16,1

	dc.w	9,-1,-1,G_BUTTON,$11
copstt:	dc.w	NORMAL
	dc.l	copms
	dc.w	19,5,16,1

	dc.w	10,-1,-1,G_BUTTON,$11
frestt:	dc.w	NORMAL
	dc.l	frems
	dc.w	1,7,16,1

	dc.w	11,-1,-1,G_BUTTON,$11
lststt:	dc.w	NORMAL
	dc.l	lstms
	dc.w	19,7,16,1

	dc.w	12,-1,-1,G_BUTTON,$11
delstt:	dc.w	NORMAL
	dc.l	delms
	dc.w	1,9,16,1

	dc.w	13,-1,-1,G_BUTTON,$11
verstt:	dc.w	NORMAL
	dc.l	verms
	dc.w	19,9,16,1

	dc.w	14,-1,-1,G_BUTTON,$11
tesstt:	dc.w	NORMAL
	dc.l	tesms
	dc.w	1,11,34,1

	dc.w	2,-1,-1,G_BUTTON,$11
cnvstt:	dc.w	NORMAL
	dc.l	cnvms
	dc.w	1,13,34,1

	dc.w	22,16,21,G_BOX,NONE,SHADOWED
	dc.l	$FF1100
	dc.w	38,1,26,13

	dc.w	17,-1,-1,G_BUTTON,SELECTABLE
retstt:	dc.w	NORMAL
	dc.l	retms
	dc.w	2,1,22,1

	dc.w	18,-1,-1,G_BUTTON,SELECTABLE
sucstt:	dc.w	NORMAL
	dc.l	sucms
	dc.w	2,3,22,1

	dc.w	19,-1,-1,G_BUTTON,SELECTABLE
sumstt:	dc.w	NORMAL
	dc.l	summs
	dc.w	2,5,22,1

	dc.w	20,-1,-1,G_BUTTON,SELECTABLE
sunstt:	dc.w	NORMAL
	dc.l	sunms
	dc.w	2,7,22,1

	dc.w	21,-1,-1,G_BUTTON,SELECTABLE
holstt:	dc.w	SELECTED
	dc.l	holms
	dc.w	2,9,22,1

	dc.w	15,-1,-1,G_BUTTON,SELECTABLE
crystt:	dc.w	NORMAL
	dc.l	cryms
	dc.w	2,11,22,1

	dc.w	23,-1,-1,G_FBOXTEXT,EDITABLE,NORMAL
	dc.l	tinf0
	dc.w	2,15,16,1

	dc.w	24,-1,-1,G_FBOXTEXT,EDITABLE,NORMAL
	dc.l	tinf1
	dc.w	20,15,16,1

	dc.w	1,-1,-1,G_FBOXTEXT,EDITABLE,NORMAL
	dc.l	tinf2
	dc.w	38,15,26,1

	dc.w	26,-1,-1,G_BUTTON,$7
arcstt:	dc.w	NORMAL
	dc.l	arcms
	dc.w	42,19,12,2

	dc.w	27,-1,-1,G_BUTTON,$5
exstt:	dc.w	NORMAL
	dc.l	exitms
	dc.w	56,19,12,2

	dc.w	0,28,30,G_BOX,NONE,SHADOWED
	dc.l	$FF1100
	dc.w	2,19,37,2

	dc.w	29,-1,-1,G_STRING,NONE,NORMAL
	dc.l	title1
	dc.w	0,0,19,1

	dc.w	30,-1,-1,G_TEXT,NONE,NORMAL
	dc.l	tinf3
	dc.w	20
authry:	dc.w	0,16,1

	dc.w	27,-1,-1,G_TEXT,LASTOB,NORMAL
	dc.l	tinf4
	dc.w	0,1,37,1

	dc.l	arcbox

* List device box

lstbox:	dc.w	-1,1,1,G_BOX,NONE,SHADOWED
	dc.l	$21133
	dc.w	0,0,39,13

	dc.w	0,2,7,G_BOX,NONE,NORMAL
	dc.l	$FF1100
	dc.w	2,1,35,11

	dc.w	3,-1,-1,G_STRING,NONE,SELECTED
	dc.l	devms
	dc.w	0,0,35,2

	dc.w	4,-1,-1,G_BUTTON,$11
scrstt:	dc.w	SELECTED
	dc.l	scrms
	dc.w	2,4,9,2

	dc.w	5,-1,-1,G_BUTTON,$11
prtstt:	dc.w	NORMAL
	dc.l	prtms
	dc.w	13,4,9,2

	dc.w	6,-1,-1,G_BUTTON,$11
dskstt:	dc.w	NORMAL
	dc.l	dskms
	dc.w	24,4,9,2

	dc.w	7,-1,-1,G_BUTTON,$7
okstt:	dc.w	NORMAL
	dc.l	okms
	dc.w	9,8,7,2

	dc.w	1,-1,-1,G_BUTTON,$25,NORMAL
	dc.l	cncms
	dc.w	19,8,7,2

	dc.l	lstbox


* Text for dialog objects

addms:	dc.b	"ADD to Archive",0
extms:	dc.b	"EXTRACT from Arc",0
movms:	dc.b	"MOVE to Archive",0
runms:	dc.b	"RUN from Arc",0
updms:	dc.b	"UPDATE Archive",0
copms:	dc.b	"COPY to StdOut",0
frems:	dc.b	"FRESHEN Archive",0
lstms:	dc.b	"LIST",0
delms:	dc.b	"DELETE from Arc",0
verms:	dc.b	"VERBOSE LIST",0
tesms:	dc.b	"Test Archive",0
cnvms:	dc.b	"Convert to new packing method",0
retms:	dc.b	"Retain Backup",0
sucms:	dc.b	"Suppress Compression",0
summs:	dc.b	"Suppress Warnings",0
sunms:	dc.b	"Suppress Notes",0
holms:	dc.b	"Hold Screen",0
cryms:	dc.b	"Encrypt / Decrypt",0
arcms:	dc.b	"ARC!",0
exitms:	dc.b	"EXIT",0
title1:	dc.b	" ARC Shell II  v1.0",0
author:	dc.b	"by Charles F. Johnson",0
null:	dc.b	0
copyrt:	dc.b	"Copyright 1987 Little Green Footballs Software",0
atext:	dc.b	'_',0
atemp:	dc.b	'ARC Drive: _',0
avalid:	dc.b	'X',0
dtext:	dc.b	'_',0
dtemp:	dc.b	'DATA Drive: _',0
dvalid:	dc.b	'X',0
etext:	dc.b	"____",0
etemp:	dc.b	"Encryption keyword: ____",0
evalid:	dc.b	"XXXX",0

devms:	dc.b	'       List to which device?',0

scrms:	dc.b	'Screen',0
prtms:	dc.b	'Printer',0
dskms:	dc.b	'Disk',0
okms:	dc.b	'OK',0
cncms:	dc.b	'CANCEL',0

* Alert box text for wrong res message

nolow:	dc.b	'[3][ARC Shell II really must be |'
	dc.b	'seen in medium or high res to |'
	dc.b	'be fully appreciated! ]'
	dc.b	'[ Abort ]'

itmtxt:	dc.b	'ITEM SELECTOR',0

clrhom:	dc.b	27,'E',0

fnmsg:	dc.b	'Filename: '
fn2:	dc.b	'             ',0

i_arcn:	dc.b	' Choose an ARC file: '
ia_dum:	dc.b	0
ia_len	=	ia_dum-i_arcn

i_datn:	dc.b	' Choose the data file(s): '
id_dum:	dc.b	0
id_len	=	id_dum-i_datn

	.ifeq	harddisk
i_wher:	dc.b	' Where is ARC.TTP? '
iw_dum:	dc.b	0
iw_len	=	19
	.endc

i_lfil:	dc.b	' List to which file? '
il_dum:	dc.b	0
il_len	=	il_dum-i_lfil

retmsg:	dc.b	13,10,0

env:	dc.b	0,0

	.ifeq	harddisk
arcn1:	dc.b	'ARC.TTP',0
	.endc

	.ifne	harddisk
arcn1:	dc.b	'C:\ARC.TTP',0
	.endc

adnam:	dc.b	'\*.ARC',0

ddnam:	dc.b	'\*.*',0

	even

g_mous:	dc.w	78,1,1,1,0
f_sel:	dc.w	90,0,2,2,0
r_obfx:	dc.w	114,1,1,1,0
f_alrt:	dc.w	52,1,1,1,0
f_cntr:	dc.w	54,0,5,1,0
f_do:	dc.w	50,1,2,1,0
f_dial:	dc.w	51,9,1,1,0
o_cdrw:	dc.w	42,6,1,1,0
o_chng:	dc.w	47,8,1,1,0

aespb:	dc.l	contrl,global,intin,intout,addrin,addrout

	bss
	even

boxadr:	ds.l	1
itmadr:	ds.l	1
iasav:	ds.l	1
diradr:	ds.l	1
filadr:	ds.l	1

ilensv:	ds.w	1

res:	ds.w	1
diflag:	ds.w	1
dfflag:	ds.w	1
prtflg:	ds.w	1
selobj:	ds.w	1
state:	ds.w	1
cx:	ds.w	1
cy:	ds.w	1
cw:	ds.w	1
ch:	ds.w	1

contrl:	ds.w	12
intin:	ds.w	128
intout:	ds.w	128
global:
apvrsn:	ds.w	1
apcont:	ds.w	1
apid:	ds.w	1
apprvt:	ds.l	1
apptre:	ds.l	1
ap1rsv:	ds.l	1
ap2rsv:	ds.l	1
ap3rsv:	ds.l	1
ap4rsv:	ds.l	1
addrin:	ds.w	128
addrout:ds.w	128

	.ifeq	harddisk
whrfil:	ds.b	16
	.endc

afile:	ds.b	16
dfile:	ds.b	16
lfile:	ds.b	16

cmdlin:	ds.b	$200

arcnam:	ds.b	64

	.ifeq	harddisk
whrdir:	ds.b	64
	.endc

arcdir:	ds.b	64

datdir:	ds.b	64

devdir:	ds.b	64

curpth:	ds.b	64

pathnm:	ds.b	64

dta:	ds.b	44

	ds.l	300
nstack:	ds.l	1
	ds.w	10
