PROGRAM Animate;
  { Put GemRast.O and Blitscrn.o in additional link files under link options}

  CONST
    {$I gemconst.pas}

  TYPE
    {$I gemtype.pas}

    Form_Format = ( Device_Format, Standard ) ;
    Mem_Form_Def = RECORD
                     mem : long_integer ;
                     pw : integer ;
                     ph : integer ;
                     width : integer ;
                     format : Form_Format ;
                     planes : integer ;
                     res1 : integer ;
                     res2 : integer ;
                     res3 : integer ;
                   END ;
    buffer = Packed ARRAY[1..8000] OF char;


  VAR
    key,tmr,flag,window,xw,yw,ww,hw,mx,my,event,dum : Integer;
    scrn0,scrn1,scrn2,scrn3 : buffer;
    msg : Message_Buffer;
    wind_name : window_title;
  {$I gemsubs.pas}


PROCEDURE Blit_Screen(x,y,w,h,dir : integer ; VAR scrn_ary : buffer );
    EXTERNAL;

PROCEDURE Draw_Ghost(x,y,flg : Integer);
 BEGIN  {Draw_Ghost}
  Paint_Rect(x,y,16,14);  {block}
  Plot(x+flg,y+14);  Plot(x+flg+4,y+14);
  Plot(x+flg+8,y+14);  Plot(x+flg+12,y+14);  {feet}
  Line_Color(0);
  Plot(x+flg+4,y+4);  Plot(x+flg+8,y+4);
  Plot(x+flg+4,y+5);  Plot(x+flg+8,y+5);  {eyes}
 END;  {Draw_Ghost}

PROCEDURE  Ghost(flg : Integer);
 BEGIN  {Ghost}
  Paint_Color(2);
  Line_Color(2);
  Draw_Ghost(45,25,flg);
  Paint_Color(1);
  Line_Color(1);
  Draw_Ghost(10,50,flg);
  Paint_Color(3);
  Line_Color(3);
  Draw_Ghost(45,50,flg);
 END;  {Ghost}

PROCEDURE Erase ;
 BEGIN
   Paint_Color(white);
   Paint_Rect(0,25,112,50)  {erase}
 END;

 BEGIN  {Animate}
  IF Init_Gem>=0 THEN
   BEGIN  {main program}
    tmr := 100;
    flag := 0;
    Init_Mouse;
    wind_name:='ANIMATION';
    window:=New_Window(G_Name|G_Close,wind_name,0,0,0,0);
    Open_Window(window,0,0,0,0);
    Work_Rect(window,xw,yw,ww,hw);
    Paint_Color(White);
    Paint_Style(Solid);
    Hide_Mouse;
    Paint_Rect(xw,yw,ww,hw); {fill the window with white backround}
    Erase;  {begin with clean slate}
    Paint_Color(2);
    Paint_Style(Solid);
    Paint_Arc(25,32,15,7,0,3600);   {first shape}
    Ghost(0);
    Blit_Screen(0,25,112,50,0,scrn0);  {save}
    Erase;
    Paint_Color(2);
    Paint_Arc(25,32,15,7,200,3400);  {second shape}
    Ghost(1);
    Blit_Screen(0,25,112,50,0,scrn1);  {save}
    Erase;
    Paint_Color(2);
    Paint_Arc(25,32,15,7,400,3200);  {third shape}
    Ghost(2);
    Blit_Screen(0,25,112,50,0,scrn2);  {save}
    Erase;
    Paint_Color(2);
    Paint_Arc(25,32,15,7,600,3000);  {fourth shape}
    Ghost(3);
    Blit_Screen(0,25,112,50,0,scrn3);  {save}
    Erase;
    Draw_String(xw,yw+10,'Move mouse to move figure, press up/down arrows');
    Draw_String(xw,yw+20,'to decrease/increase animation speed, click close');
    Draw_String(xw,yw+30,'box to end this demo.');
    Show_Mouse;
    WHILE (msg[0]<>WM_Closed) DO BEGIN  {While}
     event:=Get_Event(E_Message|E_Keyboard|E_Timer,1,1,1,tmr,false,0,0,0,0,
                      false,0,0,0,0,msg,key,dum,dum,mx,my,dum);
     IF event & E_Keyboard <> 0 THEN BEGIN  {process key press}
      IF key = $4800 THEN BEGIN {up arrow}
       tmr:=tmr+10;
       IF tmr>1000 THEN tmr:=1000
      END;  {up arrow}
      IF key = $5000 THEN BEGIN {down arrow}
       tmr :=tmr-10;
       IF tmr<1 THEN tmr:=1
      END  {down arrow}
     END;  {process key press}
     IF event & E_Timer <> 0 THEN BEGIN  {timer event}
       flag:=flag+1;
       IF flag=7 THEN flag:=1;
       Hide_Mouse;
       IF flag = 1 THEN
        Blit_Screen(mx,my,112,50,1,scrn0);  {draw}
       IF flag = 2 THEN
        Blit_Screen(mx,my,112,50,1,scrn1);  {draw}
       IF flag = 3 THEN
        Blit_Screen(mx,my,112,50,1,scrn2);  {draw}
       IF flag = 4 THEN
        Blit_Screen(mx,my,112,50,1,scrn3);  {draw}
       IF flag = 5 THEN
        Blit_Screen(mx,my,112,50,1,scrn2);  {draw}
       IF flag = 6 THEN
        Blit_Screen(mx,my,112,50,1,scrn1);  {draw}
       Show_Mouse;
      END  {timer event}
    END;  {While}
    Close_Window(window);
    Delete_Window(window);
    Exit_Gem
   END  {Animate}
END.

{end of Animate.Pas}
