{$M+,E+}
PROGRAM Blit_Screen ;


  CONST
    {$I gemconst.pas}

  TYPE
    {$I gemtype.pas}

    Form_Format = ( Device_Format, Standard ) ;
    Mem_Form_Def = RECORD
                     mem : long_integer ;
                     pw : integer ;
                     ph : integer ;
                     width : integer ;
                     format : Form_Format ;
                     planes : integer ;
                     res1 : integer ;
                     res2 : integer ;
                     res3 : integer ;
                   END ;

    Raster_Op = ( ROP_0, ROP_And, ROP_AndNot, ROP_Replace, ROP_NotAnd, ROP_NOP,
                  ROP_Xor, ROP_Or, ROP_Not_Or, ROP_Not_Xor, ROP_NotD,
                  ROP_OrNot, ROP_NotS, ROP_NotOr, ROP_Not_And, ROP_1 ) ;

    Ctrl_Parms = ARRAY[0..11] OF Integer;
    Int_In_Parms = ARRAY[0..15] OF Integer;
    Int_Out_Parms = ARRAY[0..45] OF Integer;
    Pts_In_Parms = ARRAY[0..11] OF Integer;
    Pts_Out_Parms = ARRAY[0..11] OF Integer;
    Inq_type = (Open_Vals,Ext_Vals);

  {$I gemsubs.pas}

  PROCEDURE Copy_Opaque( VAR source, dest : Mem_Form_Def ; op : Raster_Op ;
                        sx, sy, sw, sh, dx, dy, dw, dh : integer ) ;
    EXTERNAL ;

  FUNCTION Get_Port : Integer;
    EXTERNAL ;

  PROCEDURE Port_Inquire(Port_handle : Integer; VAR Int_Out : Int_Out_Parms;
                         VAR Pts_Out : Pts_Out_Parms; which : Inq_type);
    EXTERNAL;

PROCEDURE Blit_Screen(x,y,w,h,dir : integer ; scrn_ary : long_integer ) ;

    VAR
      screen,screen_form : Mem_Form_Def ;
      int_out : Int_Out_Parms ;
      pts_out : Pts_Out_Parms ;

    BEGIN
      WITH screen DO
        BEGIN
          mem := 0 ;
          pw := w;
          ph := h;
          width := (pw+15) DIV 16 ;
          format := Device_Format ;
          Port_Inquire( Get_Port, int_out, pts_out, Ext_Vals ) ;
          planes := int_out[4] ;
          res1 := 0 ;
          res2 := 0 ;
          res3 := 0 ;
        END ;
      WITH screen_form DO
        BEGIN
          mem := scrn_ary ;
          pw := w;
          ph := h;
          width := (pw+15) DIV 16 ;
          format := Device_Format ;
          Port_Inquire( Get_Port, int_out, pts_out, Ext_Vals ) ;
          planes := int_out[4] ;
          res1 := 0 ;
          res2 := 0 ;
          res3 := 0 ;
        END ;

    If dir = 0 THEN
      Copy_Opaque( screen, screen_form, ROP_Replace,
                         x, y, w, h, 0, 0, w, h )
    ELSE
      Copy_Opaque( screen_form, screen, ROP_Replace,
                         0, 0, w, h, x, y, w, h )


    END ;


  BEGIN
  END.

{ End of blitscrn.pas }
