10    rem CARTRIGE PORT TEST PROGRAM
20    rem
30    rem Randy Constan, 1987
40    rem
50    rem
90    rem INITIALIZE MACHINE LANGUAGE STRING
100   def seg = 0               'set peek/poke for 2 bytes
110   a$ = "                    " '20 spaces
115   a$ = a$+a$+a$+a$          'reserve 80 bytes of space
120   restore 1000
130   b = varptr(a$)            'get address of string a$
140   for i = 0 to 78  step 2   'put machine code program into string
150   read a: poke b+i,a
160   next i
165   rem
170   command = b        'define command area
180   cdata = b+2        'define data area
190   cartport = b+4     'define beginning of asm program
200   rem
300   rem                'set up menu
310   fullw 2
320   clearw 2
330   gotoxy 10,01:print "Cartrige Port test program"
340   gotoxy 12,03:print "1 - Write port data"
350   gotoxy 12,04:print "2 - Read port data"
360   gotoxy 12,05:print "3 - Read port status"
370   gotoxy 10,08:input "Enter command: ",x
380   poke command,x
390   if x<1 or x>3 goto 320
400   on x gosub 500,700,800
410   gotoxy 10,16:input "Press return to resume",h$
420   goto 320
430   rem
500   rem  DATA WRITE TO PORT
501   rem
510   gotoxy 10,10:input "Enter write data (0-FFFF): $",h$
520   hh$ = "&H"+h$:poke cdata,val(hh$)
530   call cartport:return
540   rem
550   rem
700   rem DATA READ FROM PORT
720   call cartport: x%=peek(cdata)
730   gotoxy 12,10: print"current data: ",hex$(x%)
740   return
750   rem
800   rem STATUS READ
810   call cartport
820   x%=peek(cdata)
830   hh$="CLEAR":if x%>=2 then x%=x%-2:hh$="SET"
840   h$ ="CLEAR":if x% then h$="SET"
850   gotoxy 12,10:print "   input data ready: ",h$
860   gotoxy 12,11:print "output data pending: ",hh$
870   return
900   rem
910   rem machine code from listing 2
920   rem
1000  data &h0000,&h0000,&h41fa,&hfffa,&h0c50,&h0001,&h670e,&h0c50
1010  data &h0002,&h671a,&h0c50,&h0003,&h6720,&h4e75,&h227c,&h00fa
1020  data &h0000,&h4280,&h303a,&hffdc,&h1231,&h0800,&h4e75,&h43fa
1030  data &hffd2,&h32b9,&h00fb,&h0000,&h4e75,&h43fa,&hffc6,&h1039
1040  data &h00fb,&h0001,&h0240,&h0003,&h3280,&h4e75,&h0000,&h0000
