/**********************************************************/
/*           C-manship listing 1, St-Log #7               */
/*              Developed with Megamax-C                  */
/**********************************************************/
#include <stdio.h>
#include <osbind.h>

#define RETURN 13
#define BACKSPACE 8
#define MAX 8
#define PRINTER_OFF 0
#define NOFILE ((FILE *)0)

FILE *fopen();
FILE *fclose();

int work_in[11];
int work_out[57];
int handle;

int contrl[12];
int intin[128];
int ptsin[128];
int intout[128];
int ptsout[128];

struct name {
            char fname[11];
            char lname[11];
    };
struct rec {
        struct name names;
        char street[30];
        char city[30];
    };

main()
{
   int num_recs, load;
   struct rec address[MAX];

   open_vwork();
   num_recs = load_file(address, &load);
   output(address, num_recs);
   if (load=='N' || load=='n')
      save_file(address, num_recs);
   printf("press key\n");
   Cconin();
   v_clsvwk(handle);
}

open_vwork()
{
    int i;
    for (i=0; i<10; work_in[i++] = 1);
    work_in[10] = 2;
    v_opnvwk(work_in, &handle, work_out);
}

load_file(recp, load)
struct rec *recp;
int *load;
{
   int num_recs;

   Cconws("Load file? ");
   while((*load=Cconin)!='Y' && *load!='y' && *load!='N' && *load!='n'); 
   printf("\n\n");
   if (*load == 'N' || *load == 'n')
      num_recs = get_records(recp);
   else
      num_recs = disk_file(recp);
   return(num_recs);
}

get_records(recp)
struct rec *recp;
{
   int ans, i;

   ans = 'y';
   i = -1;
   while ((ans=='Y' || ans=='y') && i+1<MAX) {
      ++i;
      Cconws("FIRST NAME: ");
      get_str(recp->names.fname, 10);
      Cconws("\n LAST NAME: ");
      get_str(recp->names.lname, 10);
      Cconws("\n    STREET: ");
      get_str(recp->street, 29);
      Cconws("\n      CITY: ");
      get_str(recp->city, 29);
      Cconws("\n\nAnother (y/n)? ");
      ans = Cconin();
      printf("\n\n");
      ++recp;
   }
   return(i+1);
}

disk_file(recp)
struct rec *recp;
{
   FILE *p_file;
   char filename[15];
   int num_recs, x;

   p_file = NOFILE;
   while (p_file == NOFILE) {
      Cconws("Filename: ");
      get_str(filename,14);
      printf("\n\n");
      p_file = fopen(filename, "r");
      if (p_file == NOFILE)
         printf("No such file!\n\n");
   }
   fscanf(p_file, "%d", &num_recs);
   for (x=0; x<num_recs; ++x) {
      fscanf(p_file, "%s", recp->names.fname);
      fscanf(p_file, "%s", recp->names.lname);
      fscanf(p_file, "%s", recp->street);
      fscanf(p_file, "%s", recp->city);
      ++recp;
   }
   return(num_recs);
}

output(recp, num_recs)
struct rec *recp;
int num_recs;
{
   int status, device;

   status = PRINTER_OFF;
   while (status==PRINTER_OFF) {   
      Cconws("Print to screen or printer (s/p)? ");
          device = Cconin();
      printf("\n\n");
      if (device == 'p' || device == 'P')
         status = printer(recp, num_recs);
      else {     
         screen(recp, num_recs);
         status = -1;
      }
   }
}

save_file(recp, num_recs)
struct rec *recp;
int num_recs;
{
   FILE *p_file;
   char r,x;
   char filename[15];

   Cconws("Save file? ");
   while ((r=Cconin)!='Y' && r!='y' && r!='N' && r!='n');
   printf("\n\n");
   if (r == 'Y' || r == 'y') {
      p_file = NOFILE;
      while (p_file == NOFILE) {
         Cconws("Filename: ");
         get_str(filename, 14);
         printf("\n\n");
         if ((p_file=fopen(filename, "r")) == NOFILE)
            p_file = fopen(filename, "w");
         else {
            p_file = NOFILE;
            Cconws("File already exists.  Delete it? ");
            if ((r=Cconin()) == 'Y' || r == 'y')
               p_file = fopen(filename, "w");
               printf("\n\n");
         }
      }
      fprintf(p_file, "%d\n", num_recs);
      for (x=0; x<num_recs; ++x) {
         fprintf(p_file, "%s\n", recp->names.fname);
         fprintf(p_file, "%s\n", recp->names.lname);
         fprintf(p_file, "%s\n", recp->street);        
         fprintf(p_file, "%s\n", recp->city);
         ++recp;
      }
      fclose(p_file);
   }
}

screen(recp, num_recs)
struct rec *recp;
int num_recs;
{
   int x;

   v_enter_cur(handle);
   for (x=0; x<=num_recs-1; ++x) {
      pos_cur(x,0);
      printf("Record #%d\n", x+1);
      pos_cur(x,1);
      printf("%s %s\n", recp->names.fname, recp->names.lname);
      pos_cur(x,2);
      printf("%s\n", recp->street);
      pos_cur(x,3);
      printf("%s\n\n", recp->city);
      ++recp;
   }
}

printer(recp, num_recs)
struct rec *recp;
int num_recs;
{
   int x, status;
   FILE *p_file;

   status = Cprnout(0);
   if (status == PRINTER_OFF) {
      printf("Turn on printer!\n");
      return(status);
   }
   p_file = fopen("LST:", "w");
   p_file->_fd = 3;
   for (x=0; x<num_recs; ++x) {
      fprintf(p_file, "%s %s\n", recp->names.fname, recp->names.lname);
      fprintf(p_file, "%s\n", recp->street);
      fprintf(p_file, "%s\n", recp->city);
      fprintf(p_file, "\n\n\n");
      ++recp;
   }
   fclose(p_file);
   unlink("LST:");
   return(status);
}

pos_cur(i,l)
int i,l;
{
   int x, y;

   if ((i+1)%2 == 0)
      x = 50;
   else
      x = 10;
   y = ((i/2)*5)+4+l;
   vs_curaddress(handle,y,x);
} 

int get_str(s, mx)
char s[];
int mx;
{
   int p, code;

   p = 0;
   code = Cconin();
   while (code != RETURN && p <= mx-1) {
      if (code != BACKSPACE) {
         s[p++] = code;
      }
      else if (p > 0) {
         s[--p] = '\0';
         putchar(BACKSPACE);
         putchar(' ');
         putchar(BACKSPACE);
      }
      code = Cconin();
      s[p] = '\0';
   }
   if (p = mx)
      printf("\r\n");
}

