* ST Label Maker
*
* By Charles F. Johnson
*
* Last revision: 12/31/86  14:08:50

line1	=	12	Object in TREE #0
line2	=	13	Object in TREE #0
line3	=	14	Object in TREE #0
line4	=	15	Object in TREE #0
nameln	=	4	Object in TREE #0
labnum	=	8	Object in TREE #0
addnbt	=	7	Object in TREE #0
adupbt	=	9	Object in TREE #0
extbt	=	21	Object in TREE #0
prtbt	=	18	Object in TREE #0
prtfbt	=	19	Object in TREE #0
savbt	=	20	Object in TREE #0

	text

	move.l	a7,a5		Release memory not needed by our program
	move.l	#ustack,a7	with MSHRINK (GEMDOS $4A)
	move.l	4(a5),a5
	move.l	$C(a5),d0
	add.l	$14(a5),d0
	add.l	$1C(a5),d0
	add.l	#$0100,d0
	move.l	d0,-(sp)
	move.l	a5,-(sp)
	clr	-(sp)
	move	#$4A,-(sp)
	trap	#1
	add.l	#12,sp

	move	#4,-(sp)	Check screen resolution
	trap	#14
	addq.l	#2,sp
	move.w	d0,res

	tst	d0		Is it low res?
	bne	loadrs		No, continue
	move.l	#wrong,a5	Show alert box to let the user know
	move	#1,d5		that low res just won't cut it
	bsr	alert
	bra	really

loadrs:	move.l	#r_load,aespb	Load .RSC file using rsrc_load
	move.l	#rscnam,addrin
	bsr	aes
	tst	intout		Everything cool?
	bne	ga1		Yep, continue on your journey
	move.l	#norsc,a5	Show an alert box letting the user
	move	#1,d5		in on the fact that he's missing
	bsr	alert		our .RSC file
	bra	exit2

ga1:	move.l	#r_gadr,aespb	Get address of tree #0
	clr.l	intin
	bsr	aes
	move.l	addrout,lbtree

	move.l	lbtree,a4	Put a copyright character in the title
	move.l	#nameln,d5	since the RCS won't
	bsr	obspec
	move.b	#$BD,(a5)

	move.l	lbtree,a4	Clear the first character of each te_ptext
	move.l	#line1,d5	field in the TEDINFO structures. This is
	bsr	clrlin		so data can be entered in an uninitialized
	move.l	#line2,d5	area.
	bsr	clrlin
	move.l	#line3,d5
	bsr	clrlin
	move.l	#line4,d5
	bsr	clrlin

	move.l	#$A000,a5	This section searches for the fsel_input
s_1:	move.l	#itmtxt,a4	text "ITEM SELECTOR", then searches
	move	#12,d5		backwards for the pointer to this text
s_2:	move.b	(a5),d0		in the fsel object tree. New string
	cmp.b	(a4),d0		addresses can be poked into this location.
	beq	s_3
	addq.l	#1,a5
	bra	s_2
s_3:	move.l	a5,a0
s_4:	cmp.b	(a5)+,(a4)+
	bne	s_1
	dbf	d5,s_4
	move.l	a0,d0
	move.l	a0,iasav	Save address of original text
	move.l	a0,d1
	bclr	#0,d1		Make sure we're on a word boundary
	move.l	d1,a0
s_5:	subq.l	#2,a0
	move.l	(a0),d1
	cmp.l	d1,d0
	bne	s_5
	move.l	a0,itmadr	Save address of pointer

	or	#1,-2(a0)
	move	8(a0),ilensv

	move	#$19,-(sp)	Get current drive and set fsel_input
	trap	#1		directory area
	addq.l	#2,sp
	add.b	#65,d0
	move.b	d0,direct		

	clr	-(sp)		Get current pathname
	move.l	#curpth,-(sp)
	move	#$47,-(sp)
	trap	#1
	addq.l	#8,sp

	move.l	#direct+2,a5	Copy current pathname to fsel area and
	move.l	#curpth,a4	add a search spec of "*.LBL"
	move	#63,d5
cpypth:	tst.b	(a4)
	beq	cpth2
	move.b	(a4)+,(a5)+
	dbf	d5,cpypth
cpth2:	move.l	#lbltxt,a4
	move	#6,d5
cpth3:	move.b	(a4)+,(a5)+
	dbf	d5,cpth3

	move.l	#file,a2	Clear out the filename storage area
	move	#15,d1		for fsel_input
clrf2:	clr.b	(a2)+
	dbf	d1,clrf2

	bsr	arrow		Set arrow pointer
box1:	move.l	lbtree,boxadr	Draw dat box!
	bsr	drawbx
lablst:	move	#line1,edtflg
	bsr	formdo		Go get input
	and	#$7FFF,selobj	Mask high bit (in case of double-click)
	cmp	#prtbt,selobj	Want to print labels?
	beq	prntit		Yep. Go print 'em.
	cmp	#prtfbt,selobj	Print from file?
	beq	prtfil
	cmp	#savbt,selobj	Save label?
	beq	savlab
	cmp	#extbt,selobj	Are we through?
	beq	exit		Yep. Let's split.
	move.l	#labnum,d5
	move.l	lbtree,a4
	bsr	obspec
	move.l	#1,d5		Set digit counter
	add.l	d5,a5		Set pointer to last digit
	cmp	#adupbt,selobj	Did user click on up arrow?
	bne	dnloop		No, skip ahead
uploop:	cmp.b	#'9',(a5)	Is this digit "9"?
	bne	upl2		No, skip
	move.b	#'0',(a5)	Store "0" and go process next digit
	bra	upl3
upl2:	addq.b	#1,(a5)		Add 1 to digit and go draw the object
	bra	lredrw
upl3:	subq.l	#1,a5		Point to next digit
	dbf	d5,uploop	Count down and branch
lredrw:	move	#labnum,strtob	Set index number of object
	move	#1,mod_xy	Set modifiers for clipping rectangle
	move	#2,mod_wh
	bsr	redraw		Go draw the pup!
	bra	lablst		Go get more input
dnloop:	cmp.b	#'0',(a5)	This is the corresponding routine
	bne	dnl2		to handle the down arrow
	move.b	#'9',(a5)
	bra	dnl3
dnl2:	subq.b	#1,(a5)
	bra	lredrw
dnl3:	subq.l	#1,a5
	dbf	d5,dnloop
	bra	lredrw

* Print the current label n times

prntit:	move.l	lbtree,a4	First, find out how many labels to print
	move.l	#labnum,d5
	bsr	obspec
	bsr	cnvasc
	tst.l	d0		Is it zero?
	beq	pdone		Yes, bye-bye
	move.w	d0,numsav	Save number
	bsr	bee		Set busy bee mouse pointer

pstart:	bsr	prstat		Get printer status
	bne	pst2		It's ready, skip ahead
	bsr	closbx		Un-draw the box
	bsr	arrow		Set arrow pointer
	bsr	perror		Show printer error
	beq	nop2		Continue, skip ahead
	clr	state		Reset the selected object
	bsr	change
	bra	box1		Back to the top
nop2:	move.l	lbtree,boxadr	Draw the box
	bsr	drawbx
	bsr	bee		Set bee pointer
	bra	pstart		Try again

pst2:	move	#3,device	Set device to printer for GEMDOS WRITE
	move	#line1,countr	Set counter to 1st line of text
pstlp:	bsr	abtchk		Check for mouse button abort
	bne	pdone		Abort, exit
	clr.l	d5
	move	countr,d5	Go print this line
	bsr	printl
	bmi	pdone
	addq.w	#1,countr	Increment line counter
	move	countr,d5
	cmp	#line4+1,d5	All done?
	bne	pstlp		No, do the rest

	bsr	nextlb		Move print head to next label

	subq.w	#1,numsav	Count down number of labels
	tst	numsav		Zero yet?
	bne	pst2		No, do the rest

pdone:	clr	state		De-select the button
	bsr	change
	move	#prtbt,strtob	Re-draw the button
	clr	mod_xy
	clr	mod_wh
	bsr	redraw
	bsr	arrow		Set arrow cursor again
	bra	lablst		Back for more

prtfil:	bsr	closbx		Make the dialog box go away
	move.l	itmadr,a4	Set name and length for fsel
	move.l	#i_prt,(a4)	title line
	move	#ip_len*8,8(a4)
	move.l	#direct,a0
	bsr	fsel		Go call the ITEM SELECTOR
	tst.b	file		Empty filename?
	bne	prtf2		No, skip
px1:	clr	state		De-select object
	bsr	change
	bra	box1		Return to top
prtf2:	cmp	#1,intout+2	Did we click on OK?
	beq	prtf3		Yes, skip
	bra	px1		Exit
prtf3:	bsr	getdat		Search for filename
	beq	prtf4		Found, skip
	bsr	nfound
	bra	px1
prtf4:	move.l	dta+26,length	Save length of file
	move.l	#file,a5	Open the file
	clr	d5
	bsr	openfl
	bmi	px1		Error, skip
	move.w	d0,handle
	move.l	#header,a5	Read in first 10 bytes of file
	move.l	#10,d5
	bsr	readfl
	bmi	savxit

	move.l	#labmsg,a5	Is it "LABELS" + 2 LF/CRs?
	move.l	#header,a4
	move	#9,d5
ckhead:	cmpm.b	(a4)+,(a5)+
	beq	ckh2		Nope, let's bail
	bsr	nolabl
	bra	savxit
ckh2:	dbf	d5,ckhead

stat2:	bsr	prstat		Get printer status
	bne	readit		It's OK, skip ahead
	bsr	perror		Show error alert box
	beq	stat2		Continue? Yes, try again
	bra	savxit		Abort...let's split

readit:	move.l	lbtree,boxadr	Draw the box again
	bsr	drawbx
	bsr	bee		Set the busy bee pointer
	clr	abtfl2		Clear the second abort flag
	move.l	#10,bytcnt	Initialize byte counter
read0:	move	#line1,countr	Start at the first line
read1:	move.l	lbtree,a4
	clr.l	d5
	move	countr,d5
	bsr	obspec		Get pointer to TEDINFO in a5
	move	#32,count2
read2:	move.l	#1,d5		Read file one byte at a time
	bsr	readfl		directly into TEDINFO area
	bmi	fdone
	bsr	abtchk		Check for abort
	beq	read3		No, skip
	move	#1,abtfl2	Set flag
read3:	addq.l	#1,bytcnt	Increment the byte counter
	move.b	(a5),d5		Get byte
	cmp.b	#13,d5		Is it CR?
	beq	read4		Yes, skip
	addq.l	#1,a5		Increment pointer to string
	subq.w	#1,count2	Count characters
	bne	read2		Finished? No, do the rest
	clr.b	(a5)		Set null byte at end
	move.l	#header,a5	Throw away the line feed
	move.l	#1,d5
	bsr	readfl
	bmi	fdone		Exit if error
	addq.l	#1,bytcnt	Increment counter
	bra	read41
read4:	clr.b	(a5)		Mark end of string
read41:	move.l	#header,a5	Get CR from file
	move.l	#1,d5
	bsr	readfl
	bmi	fdone
read5:	addq.l	#1,bytcnt
	move	countr,strtob	Draw each line of text
	clr	mod_xy
	clr	mod_wh
	bsr	redraw
	bsr	abtchk		Check for abort again
	beq	read51
	move	#1,abtfl2	Abort, set the flag
read51:	addq.w	#1,countr	Increment the line counter
	move	countr,d5
	cmp	#line4+1,d5	Done all 4 lines?
	bne	read1		No, do the rest
	tst	abtfl2		Want to abort?
	bne	fdone		Yes, get outta here
	move.l	#header,a5	Get the blank line between labels
	move.l	#2,d5
	bsr	readfl
	bmi	fdone
	addq.l	#2,bytcnt	Increment byte counter
	move	#3,device	Set device handle to printer (#3)
	move	#line1,countr	Start with the first text line
read6:	bsr	abtchk		Check for abort
	bne	fdone		Ok, let's bail
	clr.l	d5		Just in case
	move	countr,d5	Get object index of current line
	bsr	printl		Go print it
	addq.w	#1,countr	Increment line counter
	move	countr,d5
	cmp	#line4+1,d5	Done 'em all?
	bne	read6		No, go back
	bsr	nextlb		Move print head to next label
	move.l	bytcnt,d0	Get number of bytes printed
	move.l	length,d1	Get total file length
	cmp.l	d1,d0		Are we done?
	blt	read0		No, not yet!
fdone:	bsr	closfl		Whew, done! Close the file
	bsr	arrow		Set arrow cursor
	clr	state
	bsr	change		Reset selected object
	move	#prtfbt,strtob	And redraw it
	clr	mod_xy
	clr	mod_wh
	bsr	redraw
	bra	lablst		Back to form_do

savlab:	bsr	closbx		Get rid of the dialog box
	move.l	itmadr,a4	Set title line of File Selector
	move.l	#i_sav,(a4)
	move	#is_len*8,8(a4)	Also set length of string
	move.l	#direct,a0
	bsr	fsel		Go get a filename
	tst.b	file		Blank?
	bne	sav2		No, skip
sx1:	clr	state		Reset object
	bsr	change
	bra	box1		And go back to form_do
sav2:	cmp	#1,intout+2	Did we click on OK?
	beq	sav3		Yes, continue
	bra	sx1
sav3:	bsr	getdat		Does this filename already exist?
	beq	sav4		Yes, skip ahead
	clr	-(sp)		Create this file and write
	pea	file		"LABELS" header
	move	#$3C,-(sp)
	trap	#1
	addq.l	#8,sp
	tst	d0
	bmi	sx1
	move.w	d0,handle

	move.l	#labmsg,a5	Write the "LABELS" header to the file
	move.l	#lablen,d5
	bsr	writfl
	bmi	sx1
	bsr	closfl		Close it

sav4:	move.l	#file,a5	Open the file
	move	#2,d5
	bsr	openfl
	bmi	box1
	move.w	d0,handle	Save handle

	bsr	bee		Set busy bee
	move.l	#header,a5	Read in first 10 bytes of file
	move.l	#10,d5
	bsr	readfl
	bmi	savxit

	move.l	#labmsg,a5	Is it "LABELS" + 2 LF/CRs?
	move.l	#header,a4
	move	#9,d5
ckhed2:	cmpm.b	(a4)+,(a5)+
	beq	ck22		Nope, let's bail
	bsr	nolabl
	bra	savxit
ck22:	dbf	d5,ckhed2

	move	#2,-(sp)	Move file pointer to end of file
	move.w	handle,-(sp)	with LSEEK
	move.l	#0,-(sp)
	move	#$42,-(sp)
	trap	#1
	add.l	#10,sp
	tst	d0
	bmi	savxit		Error? If so, bail
	move.w	handle,device	Set device for write

	move	#line1,countr
savlp:	move	countr,d5	Write each line in dialog box to file
	bsr	printl
	bmi	savxit		Error? Yep, let's split
	addq.w	#1,countr	Count lines
	move	countr,d5
	cmp	#line4+1,d5	Done?
	bne	savlp		No, do the rest

	move.l	#retmsg,a5	Write one blank line
	move.l	#2,d5
	bsr	writfl
savxit:	bsr	closfl		Close the file
	clr	state
	bsr	change		Reset selected object
	bsr	arrow
	bra	box1		And go back to the top

exit:	bsr	closbx		Erase the dialog box
	move	#2,diflag	Draw shrinking box
	bsr	dial

	move.l	itmadr,a4	Replace fsel text pointer
	move.l	iasav,(a4)
	and	#$FE,-2(a4)	Also reset to normal
	move.w	ilensv,8(a4)	and restore original lebgth

	move.l	#r_free,aespb	Free the resource memory
	bsr	aes

exit2:
really:	clr	-(sp)		Back to the desktop
	trap	#1

abtchk:	clr	abtflg
	btst	#1,$27DE	Check mouse button location
	beq	abtxit		Not pressed, skip
bwait:	btst	#1,$27DE	Wait for release
	bne	bwait
	move	#1,abtflg	Set abort flag
abtxit:	tst	abtflg
	rts

prstat:	move	#$11,-(sp)	Get printer status
	trap	#1
	addq.l	#2,sp
	tst	d0
	rts

perror:	move.l	#noprnt,a5	Show alert box and return with
	move	#1,d5		zero flag set if "Continue"
	bsr	alert
	cmp	#1,intout
	rts

nfound:	move.l	#nofnam,a5	Copy the filename to the dialog
	move	#11,d5		box area
clrnfb:	move.b	#' ',(a5)+
	dbf	d5,clrnfb
	move.l	#nofnam,a5
	move.l	#file,a4
	move	#11,d5
cpyfnm:	tst.b	(a4)
	beq	doalrt
	move.b	(a4)+,(a5)+
	dbf	d5,cpyfnm
doalrt:	move.l	#nofile,a5	Show "File Not Found" alert box
	move	#1,d5
	bra	alert

nolabl:	move.l	#nlbnam,a5	Copy filename to alert
	move	#11,d5
clrnlb:	move.b	#' ',(a5)+
	dbf	d5,clrnlb
	move.l	#nlbnam,a5
	move.l	#file,a4
	move	#11,d5
cpylnm:	tst.b	(a4)
	beq	showal
	move.b	(a4)+,(a5)+
	dbf	d5,cpylnm
showal:	move.l	#notlbf,a5	Show "Not Label File" alert box
	move	#1,d5
	bra	alert

printl:	move.l	lbtree,a4
	bsr	obspec		Get pointer to TEDINFO string (te_ptext)
	clr.l	d4
	move.l	#pbuff,a4	Move characters from TEDINFO to
	move.l	#40,d5		print buffer until null byte is reached
cpylin:	tst.b	(a5)
	beq	putret
	move.b	(a5)+,(a4)+
	addq.b	#1,d4
	dbeq	d5,cpylin
putret:	move.b	#13,(a4)+	Put LF/CR at end of line
	move.b	#10,(a4)
	addq.b	#2,d4

	move.l	#pbuff,-(sp)	Use GEMDOS write command to write
	move.l	d4,-(sp)	this line to either printer or file,
	move.w	device,-(sp)	depending on the value of "device"
	move	#$40,-(sp)
	trap	#1
	add.l	#12,sp
	tst.l	d0
	rts

* Convert ASCII decimal to binary longword
*
* Enter with:	a5= address of decimal string
*
* Exit with:	d0= converted number

cnvasc:	clr.l	d0
cnvl1:	cmpi.b	#"9",(a5)
	bhi	notdec
	cmpi.b	#"0",(a5)
	blo	notdec
	lsl.l	#1,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d1,d0
	move.b	(a5)+,d1
	andi.l	#$0F,d1
	add.l	d1,d0
	bra	cnvl1
notdec:	rts

clrlin:	bsr	obspec
	clr.b	(a5)
	rts

nextlb:	move.l	#nxtlbl,-(sp)	Send two CRs to the printer to
	move.l	#4,-(sp)	move to the next label
	move	#3,-(sp)
	move	#$40,-(sp)
	trap	#1
	add.l	#12,sp
	rts

getdat:	pea	dta		Set address of GEMDOS DTA area
	move	#$1A,-(sp)
	trap	#1
	addq.l	#6,sp

	clr	-(sp)		SFIRST - search for first name in
	move.l	#file,-(sp)	directory that matches the filespec
	move	#$4E,-(sp)
	trap	#1
	addq.l	#8,sp
	tst	d0
	rts

* Open a file
* Enter with: a5= address of filename
*	      d5= read/write mode

openfl:	move.w	d5,-(sp)
	move.l	a5,-(sp)
	move	#$3D,-(sp)
	trap	#1
	addq.l	#8,sp
	tst	d0
	rts

* Read a file
* Enter with: a5= address of buffer
*	      d5= number of bytes to read

readfl:	move.l	a5,-(sp)
	move.l	d5,-(sp)
	move.w	handle,-(sp)
	move	#$3F,-(sp)
	trap	#1
	add.l	#12,sp
	tst.l	d0
	rts

* Write to a file
* Enter with a5= address of buffer
*	     d5= number of bytes to write

writfl:	move.l	a5,-(sp)
	move.l	d5,-(sp)
	move.w	handle,-(sp)
	move	#$40,-(sp)
	trap	#1
	add.l	#12,sp
	tst.l	d0
	rts

* Close a file

closfl:	move.w	handle,-(sp)
	move	#$3E,-(sp)
	trap	#1
	addq.l	#4,sp
	tst	d0
	rts

* Calculate the address of the text in a TEDINFO structure
* Enter with: a4= object tree address
*	      d5= object index
* Exit with:  a5= address of string (that te_ptext points to)

obspec:	move.l	a4,a5
	mulu	#24,d5
	add.l	#12,d5
	add.l	d5,a5
	move.l	(a5),a5
	move.l	(a5),a5
	rts

bee:	move	#2,intin
	bra	mousie
arrow:	clr	intin
mousie:	move.l	#g_mous,aespb	graf_mouse (GEM p.384)
	bra	aes

* form_alert
* Enter with a5= address of definition string
*	     d5= number of default box

alert:	move.l	a5,addrin	Set address of string
	move.w	d5,intin	Set default box
	move.l	#f_alrt,aespb	Display alert box
	bra	aes

redraw:	clr	depth
	move.l	lbtree,drtree
	bra	obdraw

* Dialog box drawing routine
* Used to draw an entire dialog box
*
* Enter with boxadr= object tree address
*	     edtflg= index of editable text field (if any)

drawbx:	move.l	#f_cntr,aespb	First, let's call form_center
	move.l	boxadr,addrin
	bsr	aes
	move	intout+2,cx
	move	intout+4,cy
	move	intout+6,cw
	move	intout+8,ch

	clr	diflag		Reserve screen buffer memory
	bsr	dial
	move	#1,diflag	Draw expanding box
	bsr	dial
	move.l	#o_cdrw,aespb	Now, let's call objc_draw
	clr	intin		Root object gets drawn first
	move	#3,intin+2	Up to 3 levels of subordinate objects
	move	cx,intin+4	Pass coordinates obtained from form_center
	move	cy,intin+6
	move	cw,intin+8
	move	ch,intin+10
	move.l	boxadr,addrin
	bra	aes

formdo:	move.l	#f_do,aespb	Here's where the AES supervises all user
	move	edtflg,intin	input --- form_do
	move.l	boxadr,addrin
	bsr	aes
	move	intout,selobj
	rts

closbx:	move	#3,diflag	Release screen memory
	bra	dial

* form_dial
* Enter with: diflag= function number
*		      0=reserve screen memory
*		      1=draw expanding rectangle
*		      2=draw shrinking rectangle
*		      3=release screen memory

dial:	move.l	#f_dial,aespb
	move	diflag,intin
	move	#320,intin+2	This box will grow from the center
	cmp	#2,res		of the screen in either medium or hi res
	bne	cntrs1
	move	#200,intin+4
	bra	cntrs2
cntrs1:	move	#100,intin+4
cntrs2:	move	#8,intin+6
	move	#8,intin+8
	move	cx,intin+10
	move	cy,intin+12
	move	cw,intin+14
	move	ch,intin+16
	bra	aes

* objc_draw
* Enter with: strtob= index of object to draw
*	      depth=  # of subordinate objects to draw
*	      drtree= address of object tree
*	      mod_xy= x, y clipping rectangle modifier
*	      mod_wh= w, h    "         "        "

obdraw:	move.l	#o_coff,aespb
	move	strtob,intin
	move.l	drtree,addrin
	bsr	aes
	move	intout+2,d5
	add.w	mod_xy,d5
	move.w	d5,intin+4
	move.w	intout+4,d5
	add.w	mod_xy,d5
	move.w	d5,intin+6
	move.l	drtree,a5
	clr.l	d5
	move.w	strtob,d5
	mulu	#24,d5
	add.l	d5,a5
	move.w	20(a5),d5
	sub.w	mod_wh,d5
	move.w	d5,intin+8
	move.w	22(a5),d5
	sub.w	mod_wh,d5
	move.w	d5,intin+10

	move.l	#o_cdrw,aespb
	move	strtob,intin
	move	depth,intin+2
	move.l	drtree,addrin
	bra	aes

* objc_change
* Enter with: state= new object status value (GEM pg.332)

change:	move.l	#o_chng,aespb	This call changes the status of
	move	selobj,intin	an object
	clr	intin+2
	move	cx,intin+4
	move	cy,intin+6
	move	cw,intin+8
	move	ch,intin+10
	move	state,intin+12
	clr	intin+14
	move.l	boxadr,addrin
	bra	aes

* fsel_input
* Enter with a0= address of directory specification

fsel:	move.l	a0,adrsav	Save address of directory name

	move.l	#f_sel,aespb	fsel_input
	move.l	adrsav,addrin	Pass directory string address
	move.l	#file,addrin+4	Pass file name address
	bsr	aes

	clr.l	d0
	move.l	adrsav,a0
	move.b	(a0),d0		Get drive number
	sub.b	#65,d0
	move.w	d0,-(sp)
	move	#$0E,-(sp)	Set current drive
	trap	#1
	addq.l	#4,sp
	move.l	adrsav,a0	Also set pathname from fsel
	addq.l	#2,a0
	move.l	#pathnm,a1
	move	#63,d5		Search forward and copy til zero
pathlp:	tst.b	(a0)
	beq	plx1
	move.b	(a0)+,(a1)+
	dbf	d5,pathlp
plx1:	move	#63,d5
plp2:	cmp.b	#"\",-(a1)	Search backward til "\" and
	beq	plx2		set a zero after it
	dbf	d5,plp2
plx2:	addq.l	#1,a1
	clr.b	(a1)
	pea	pathnm		Set current pathname
	move	#$3B,-(sp)
	trap	#1
	addq.l	#6,sp
	rts

* AES subroutine

aes:	move.l	#aespb,d1
	move.l	#$c8,d0
	trap	#2
	rts

	data
rscnam:	dc.b	'LABELMAK.RSC',0

wrong:	dc.b	'[3][ |'
	dc.b	' This program must be seen in |'
	dc.b	' medium or high resolution to |'
	dc.b	' be fully appreciated! |'
	dc.b	' ]'
	dc.b	'[ Sorry! ]'

norsc:	dc.b	"[3][ Can't find resource file: |"
	dc.b	' |'
	dc.b	'     LABELMAK.RSC |'
	dc.b	' ]'
	dc.b	'[ Sorry! ]'

noprnt:	dc.b	'[3][ Printer is not on-line! |'
	dc.b	' |'
	dc.b	' Make sure power is on and |'
	dc.b	' connections are secure... |'
	dc.b	' ]'
	dc.b	'[ Continue | Abort ]'

nofile:	dc.b	"[3][ Can't find | | "
nofnam:	dc.b	'             |'
	dc.b	' ]'
	dc.b	'[ Cancel ]'

notlbf:	dc.b	'[3][      '
nlbnam:	dc.b	'                | |'
	dc.b	' is not a valid label file! |'
	dc.b	' ]'
	dc.b	'[ Sorry! ]'

nxtlbl:	dc.b	13,10,13,10

itmtxt:	dc.b	'ITEM SELECTOR',0
i_prt:	dc.b	' Choose a Label file to print: ',0
i_sav:	dc.b	' Save Label to which file? ',0

labmsg:	dc.b	'LABELS',13,10
retmsg:	dc.b	13,10

direct:	dc.b	'A:'
	ds.b	62

ip_len	=	i_sav-i_prt-1
is_len	=	labmsg-i_sav-1

lablen	=	direct-labmsg

lbltxt:	dc.b	'\*.LBL',0

	even
aespb:	dc.l	contrl,global,intin,intout,addrin,addrout

r_load:	dc.w	110,0,1,1,0
r_gadr:	dc.w	112,2,1,0,1
r_free:	dc.w	111,0,1,0,0
g_mous:	dc.w	78,1,1,1,0
o_cdrw:	dc.w	42,6,1,1,0
o_coff:	dc.w	44,1,3,1,0
o_chng:	dc.w	47,8,1,1,0
f_alrt:	dc.w	52,1,1,1,0
f_cntr:	dc.w	54,0,5,1,0
f_do:	dc.w	50,1,2,1,0
f_dial:	dc.w	51,9,1,1,0
f_sel:	dc.w	90,0,2,2,0

	bss
	even

lbtree:	ds.l	1
boxadr:	ds.l	1
drtree:	ds.l	1
adrsav:	ds.l	1
itmadr:	ds.l	1
iasav:	ds.l	1
length:	ds.l	1
bytcnt:	ds.l	1

res:	ds.w	1
handle:	ds.w	1
device:	ds.w	1
ilensv:	ds.w	1
numsav:	ds.w	1
countr:	ds.w	1
count2:	ds.w	1
abtflg:	ds.w	1
abtfl2:	ds.w	1
edtflg:	ds.w	1
diflag:	ds.w	1
cx:	ds.w	1
cy:	ds.w	1
cw:	ds.w	1
ch:	ds.w	1
mod_xy:	ds.w	1
mod_wh:	ds.w	1
selobj:	ds.w	1
state:	ds.w	1
strtob:	ds.w	1
depth:	ds.w	1

pbuff:	ds.b	64

* GEM arrays

	even
contrl:	ds.w	12
intin:	ds.w	128
intout:	ds.w	128
global:
apvrsn:	ds.w	1
apcont:	ds.w	1
apid:	ds.w	1
apprvt:	ds.l	1
apptre:	ds.l	1
ap1rsv:	ds.l	1
ap2rsv:	ds.l	1
ap3rsv:	ds.l	1
ap4rsv:	ds.l	1

addrin:	ds.w	128
addrout:ds.w	128

pipe:	ds.b	32

header:	ds.b	10
file:	ds.w	8
pathnm:	ds.b	64
curpth:	ds.b	64
dta:	ds.b	44

	ds.l	300		Reserve 1200 bytes for stack
ustack:	ds.l	1
	ds.w	10
