

*** X.S
        text                            code segment
        move.l  #sign_on,-(a7)          get start message
        move.w  #9,-(a7)                code=display string
        trap    #1                      do it
        addq.l  #6,a7                   fix stack

        bsr     keycodes                go look at keyboard

        move.l  #sign_off,-(a7)         get end message
        move.w  #9,-(a7)                code=display string
        trap    #1                      do it
        move.w  #0,-(a7)                code=exit program
        trap    #1                      do it

keycodes:
        move.w  #1,-(a7)                code=conin
        trap    #1                      do it
        addq.l  #2,a7                   pop arg
        lsr.l   #8,d0                   get scan code
        lsr.l   #8,d0

        movea.l #keys,a0                messages
        movea.l #codes,a1               scan codes
        move.l  #nrcodes,d1             number of good keys
loop:
        cmp.w   (a1)+,d0                good code?
        bne.s   next                    if not
        move.l  (a0),-(a7)              else get message
        move.w  #9,-(a7)                code=display string
        trap    #1                      do it
        addq.l  #6,a7                   pop args
        bra     keycodes                get another key
next:
        addq.l  #4,a0                   point to next message
        subq.l  #1,d1                   dec loop count
        bne     loop                    if more special keys
        cmpi.w  #F1,d0                  else: F1 key?
        bne     keycodes                if not
keys_exit:
        rts                             else leave

        data                            data segment
F1      equ     $3b                     F1 key equate

sign_on  dc.b   'Hello',10,13,0         start message
sign_off dc.b   'Good-bye',10,13,0      end message

        even                            align table
codes   equ     *                       table of scan codes
ESC     dc.w    $01                     escape
CUP     dc.w    $48                     cursor up
CDN     dc.w    $50                     cursor down
F10     dc.w    $44                     function 10
nrcodes equ     4                       manually entered

        even                            align table
keys    equ     *                       table of messages
        dc.l    k1                      address of first msg
        dc.l    k2                      of 2nd message
        dc.l    k3                      of 3rd message
        dc.l    k4                      of 4th message
k1      dc.b    10,13,'Escape key',10,13,0
k2      dc.b    10,13,'Cursor Up',10,13,0
k3      dc.b    10,13,'Cursor Down',10,13,0
k4      dc.b    10,13,'F10 key',10,13,0
k_end   equ     *
        
