                ;cartrige port test utility for ST BASIC

command: dc.w 0 ;space for command entry
data:    dc.w 0 ;space for I/O data

start:
 lea command(pc),a0      ;a0 -> command word
 cmp #1,(a0)             ;determine command.
 beq.s write
 cmp #2,(a0)
 beq.s read
 cmp #3,(a0)
 beq.s status
 rts                     ;exit if invalid!

write:
 move.l #$FA0000,A1      ;-> ROM4 address range
 clr.l d0
 move.w data(pc),d0      ;fetch word to write
 move.b 0(a1,d0.l),d1    ;fake a write to
 rts                     ;the port and exit!

read:
 lea data(pc),a1         ;fetch data address.
 move.w $FB0000,(a1)     ;get port data
 rts                     ;and exit

status:
 lea data(pc),a1         ;fetch data address.
 move.b $FB0001,d0       ;read odd byte
 and #3,d0               ;mask off unused bits,
 move d0,(a1)            ;and store status.
 rts
