1000  REM ChemCalc Version 1.0
1010  REM Copyright (c) 1989 by ST-Log
1020  REM
1030  on error goto 2020
1040  gosub INIT: goto CALCWT
1050  INIT:
1060  fullw 2: clearw 2: color 3
1070  gotoxy 29,4: ? "ChemCalc"
1080  gotoxy 26,6: ? "By Richard Repka"
1090  gotoxy 28,7: ? "From ST-Log"
1100  gotoxy 27,12: ?"Initializing... ";
1110  dim etable$(106), wtable(106), fs$(25), fsv(25), pctable$(25), pcv(25)
1120  for i = 1 to 106: read element$: etable$(i) = element$: next i
1130  restore 2130
1140  for i = 1 to 106: read wt: wtable(i) = wt: next i
1150  for i = 1 to 800: next i
1160  INITFS:
1170  for i = 1 to 25: fs$(i)="": fsv(i) = 0: next i
1180  for i = 1 to 25: pctable$(i)="": pcv(i) = 0: next i
1190  totpcv = 0: weight = 0: radmult = 1: hydmult = 1
1200  return
1210  CALCWT:
1220  clearw 2: color 1: gosub INITFS
1230  gotoxy 2,0: line input "Enter Formula: "; f$
1240  f$ = f$ + "\": cnt = 1: pnt = 1: sub = 1
1250  test$ = mid$(f$,pnt,1)
1260  if test$ >= "A" and test$ <= "Z" then goto FINDELE
1270  if test$ = "(" or test$ = "[" then goto RADICAL
1280  if test$ = "*" then goto HYDCOMP
1290  if test$ = "\" then goto GETWT
1300  pnt = pnt + 1: goto 1250
1310  HYDCOMP:
1320  cnt = cnt + 1
1330  pnt = pnt + 1: test$ = mid$(f$,pnt,1)
1340  if test$ < "0" or test$ > "9" then 1360
1350  goto 1330
1360  hydmult = val(mid$(f$,cnt,pnt-cnt)): cnt = pnt: goto 1250
1370  FINDELE:
1380  pnt = pnt + 1: test$ = mid$(f$,pnt,1)
1390  if test$ = "\" then temp$ = mid$(f$,cnt,pnt-cnt): gosub SEPARATE
1400  if pnt = len(f$) then goto GETWT
1410  if test$ >= "A" and test$ <= "Z" then 1440
1420  if test$ = "(" or test$ = "*" then 1440
1430  goto 1380
1440  temp$ = mid$(f$,cnt,pnt-cnt): gosub SEPARATE: cnt = pnt
1450  goto 1250
1460  SEPARATE:
1470  j = 1
1480  if mid$(temp$,j,1) > "0" and mid$(temp$,j,1) <= "9" then 1520
1490  if j <> len(temp$) then j = j + 1: goto 1480
1500  fs$(sub) = temp$
1510  fsv(sub) = (1 * hydmult) * radmult: sub = sub + 1: return
1520  fs$(sub) = left$(temp$,j-1)
1530  fsv(sub) = (val(mid$(temp$,j)) * hydmult) * radmult
1540  sub = sub + 1: return
1550  GETWT:
1560  for i = 1 to sub -1:  elepnt = 1
1570  if etable$(elepnt) = fs$(i) then 1590
1580  elepnt = elepnt + 1: goto 1570
1590  weight = weight + wtable(elepnt) * fsv(i)
1600  next i
1610  color 2: gotoxy 2,2: ? "Working... ";
1620  gosub GROUP
1630  gotoxy 2,2: ? "Total Molecular Weight: ";weight;" grams/mole"
1640  color 3: gotoxy 20,4: ? "Element            Composition"
1650  gotoxy 20,5: ? "------------------------------"
1660  PRTPCT:
1670  for i = 1 to q
1680  pct = cint((pcv(i)*pctval)*100) / 100
1690  if len(str$(pct)) > 5 then pct = pct + 0.00001
1700  tpos = 40 + (5 - len(str$(pct)))
1710  gotoxy 22,i+5: ? pctable$(i): gotoxy tpos,i+5: ? pct;"%"
1720  next i: color 1
1730  gotoxy 2,16: ? "Another formula? [y or n]... ";
1740  line input choice$
1750  if choice$ = "y" or choice$ = "Y" then goto CALCWT
1760  end
1770  RADICAL:
1780  x = instr(pnt,f$,")")
1790  for i = x+1 to len(f$)
1800  if mid$(f$,i,1) < "0" or mid$(f$,i,1) > "9" then 1820
1810  next i
1820  radmult = val(mid$(f$,x+1,i-x+1)): pnt = pnt + 1: cnt = pnt: om = i
1830  if pnt = x then 1880
1840  pnt = pnt + 1: test$ = mid$(f$,pnt,1)
1850  if test$ >= "A" and test$ <= "Z" then 1870
1860  goto 1830
1870  temp$ = mid$(f$,cnt,pnt-cnt): gosub SEPARATE: cnt = pnt: goto 1830
1880  temp$ = mid$(f$,cnt,pnt-cnt): gosub SEPARATE: cnt = om: pnt = om
1890  radmult = 1: goto 1250
1900  GROUP:
1910  q = 0
1920  for i = 1 to 106: telecnt = 0
1930  for j = 1 to sub
1940  if etable$(i) = fs$(j) then telecnt = telecnt + fsv(j)
1950  next j
1960  if telecnt = 0  then goto 1990
1970  q = q + 1: pctable$(q) = etable$(i): pcv(q) = telecnt * wtable(i)
1980  totpcv = totpcv + pcv(q)
1990  next i
2000  pctval = 100 / totpcv
2010  return
2020  ERRORS:
2030  gotoxy 2,2:? "An error has occured, check formula and re-enter"
2040  goto 1730
2050  ELEMENTS:
2060  data H,He,Li,Be,B,C,N,O,F,Ne,Na,Mg,Al,Si,P,S,Cl,Ar
2070  data K,Ca,Sc,Ti,V,Cr,Mn,Fe,Co,Ni,Cu,Zn,Ga,Ge,As,Se
2080  data Br,Kr,Rb,Sr,Y,Zr,Nb,Mo,Tc,Ru,Rh,Pd,Ag,Cd,In,Sn
2090  data Sb,Te,I,Xe,Cs,Ba,La,Ce,Pr,Nd,Pm,Sm,Eu,Gd,Tb,Dy
2100  data Ho,Er,Tm,Yb,Lu,Hf,Ta,W,Re,Os,Ir,Pt,Au,Hg,Tl,Pb
2110  data Bi,Po,At,Rn,Fr,Ra,Ac,Th,Pa,U,Np,Pu,Am,Cm,Bk,Cf
2120  data Es,Fm,Md,No,Lr,Unq,Unp,Unh
2130  WEIGHTS:
2140  data 1.008,4.003,6.941,9.012,10.810,12.011,14.007
2150  data 16.000,18.998,20.179,22.990,24.305,26.982
2160  data 28.086,30.974,32.060,35.453,39.948,39.098
2170  data 40.080,44.956,47.900,50.942,51.996,54.938
2180  data 55.847,58.933,58.700,63.546,65.380,69.720
2190  data 72.590,74.922,78.960,79.904,83.800,85.468
2200  data 87.620,88.906,91.220,92.906,95.940,98.000
2210  data 101.070,102.906,106.400,107.868,112.410,114.820
2220  data 118.690,121.750,127.600,126.905,131.300,132.905
2230  data 137.330,138.906,140.120,140.908,144.240,145.000
2240  data 150.400,151.960,157.250,158.925,162.500,164.930
2250  data 167.260,168.934,173.040,174.967,178.490,180.948
2260  data 183.850,186.207,190.200,192.220,195.090,196.967
2270  data 200.590,204.370,207.200,208.980,209.000,210.000
2280  data 222.000,223.000,226.025,227.028,232.038,231.036
2290  data 238.029,237.048,244.000,243.000,247.000,247.000
2300  data 251.000,252.000,257.000,258.000,259.000,260.000
2310  data 261.000,262.000,263.000
